import es
import cfglib
import popuplib
import gamethread
import playerlib

info = es.AddonInfo()
info['name'] = "Undead Buy"
info['basename'] = "undead_buy"
info['version'] = "1.0"
info['author'] = "Undead"
info['url'] = ""
info['description'] = "Weapon/Item Buy Menu for Players"

es.ServerVar(info['basename'], info['version'], info['description']).makepublic()

cfg = cfglib.AddonCFG(es.getAddonPath('undead_buy') + '/config.cfg')
buy_cmd = cfg.cvar('ub_buy_cmd', '!buy', 'Commands to open Buy menu')
glock = cfg.cvar('ub_glock', '400', 'Price for Glock 18')
usp = cfg.cvar('ub_usp', '500', 'Price for USP Tactical')
p228 = cfg.cvar('ub_p228', '600', 'Price for P228')
deagle = cfg.cvar('ub_deagle', '650', 'Price for Desert Eagle')
fiveseven = cfg.cvar('ub_fiveseven', '750', 'Price for FN-57')
elite = cfg.cvar('ub_elite', '800', 'Price for Dual 96G Elite Berettas')
mac10 = cfg.cvar('ub_mac10', '1400', 'Price for MAC10')
tmp = cfg.cvar('ub_tmp', '1250', 'Price for TMP')
mp5 = cfg.cvar('ub_mp5', '1500', 'Price for MP5-Navy')
ump = cfg.cvar('ub_ump', '1700', 'Price for UMP')
p90 = cfg.cvar('ub_p90', '2350', 'Price for P90')
m3 = cfg.cvar('ub_m3', '1700', 'Price for M3 Super 90')
xm1014 = cfg.cvar('ub_xm1014', '300', 'Price for XM1014')
galil = cfg.cvar('ub_galil', '2000', 'Price for IMI Galil')
famas = cfg.cvar('ub_famas', '2250', 'Price for FAMAS')
ak47 = cfg.cvar('ub_ak47', '2500', 'Price for AK47')
m4a1 = cfg.cvar('ub_m4a1', '3100', 'Price for M4A1 Carbine')
sg552 = cfg.cvar('ub_sg552', '3500', 'Price for SG-552 Commando')
aug = cfg.cvar('ub_aug', '3500', 'Price for AUG')
m249 = cfg.cvar('ub_m249', '5750', 'Price for M249-SAW')
scout = cfg.cvar('ub_scout', '2750', 'Price for Scout')
g3sg1 = cfg.cvar('ub_g3sg1', '5000', 'Price for G3/SG-1')
sg550 = cfg.cvar('ub_sg550', '4200', 'Price for SG-550')
awp = cfg.cvar('ub_awp', '4750', 'Price for Artice Warfare Police')
flashbang = cfg.cvar('ub_flashbang', '200', 'Price for Flashbang Grenade')
smokegrenade = cfg.cvar('ub_smokegrenade', '300', 'Price for Smoke Grenade')
hegrenade = cfg.cvar('ub_hegrenade', '300', 'Price for High-Explosive Grenade')
kevlar = cfg.cvar('ub_kevlar', '600', 'Price for Kevlar')
assaultsuit = cfg.cvar('ub_assaultsuit', '1000', 'Price for Kevlar and Helmet')
nvgs = cfg.cvar('ub_nvgs', '1250', 'Price for Nightvision')
defusekit = cfg.cvar('ub_defusekit', '200', 'Price for Bomb Defusal Kit')
cfg.write()

buyAllowed = False 

def load():
  cfg.execute()
  if not es.exists('saycommand', buy_cmd):
    es.regsaycmd(buy_cmd, 'undead_buy/buy_cmd_reg')
  bmenu = popuplib.easymenu('bmenu', '_popup_choice', bmenu_select)
  bmenu.settitle("Buy Menu:")
  bmenu.addoption('1', "Pistols")
  bmenu.addoption('2', "Sub-Machine Guns")
  bmenu.addoption('3', "Shotguns")
  bmenu.addoption('4', "Rifles")
  bmenu.addoption('5', "Machine Guns")
  bmenu.addoption('6', "Sniper Rifles")
  bmenu.addoption('7', "Grenades")
  bmenu.addoption('8', "Miscellaneous")
  pmenu = popuplib.easymenu('pmenu', '_popup_choice', pmenu_select)
  pmenu.settitle("Pistols:")
  pmenu.addoption('1', "Glock 18 ($%s)"%int(glock))
  pmenu.addoption('2', "USP Tactical ($%s)"%int(usp))
  pmenu.addoption('3', "P228 ($%s)"%int(p228))
  pmenu.addoption('4', "Desert Eagle ($%s)"%int(deagle))
  pmenu.addoption('5', "FN-57 ($%s)"%int(fiveseven))
  pmenu.addoption('6', "Dual 96G Elite Berettas ($%s)"%int(elite))
  smmenu = popuplib.easymenu('smmenu', '_popup_choice', smmenu_select)
  smmenu.settitle("Sub-Machine Guns:")
  smmenu.addoption('1', "MAC10 ($%s)"%int(mac10))
  smmenu.addoption('2', "TMP ($%s)"%int(tmp))
  smmenu.addoption('3', "MP5 Navy ($%s)"%int(mp5))
  smmenu.addoption('4', "UMP ($%s)"%int(ump))
  smmenu.addoption('5', "P90 ($%s)"%int(p90))
  smenu = popuplib.easymenu('smenu', '_popup_choice', smenu_select)
  smenu.settitle("Shotguns:")
  smenu.addoption('1', "M3 Super 90 ($%s)"%int(m3))
  smenu.addoption('2', "XM1014 ($%s)"%int(xm1014))
  rmenu = popuplib.easymenu('rmenu', '_popup_choice', rmenu_select)
  rmenu.settitle("Rifles:")
  rmenu.addoption('1', "IMI Galil ($%s)"%int(galil))
  rmenu.addoption('2', "FAMAS ($%s)"%int(famas))
  rmenu.addoption('3', "AK47 ($%s)"%int(ak47))
  rmenu.addoption('4', "M4A1 Carbine ($%s)"%int(m4a1))
  rmenu.addoption('5', "SG-552 Commando ($%s)"%int(sg552))
  rmenu.addoption('6', "AUG ($%s)"%int(aug))
  mgmenu = popuplib.easymenu('mgmenu', '_popup_choice', mgmenu_select)
  mgmenu.settitle("Machine Guns:")
  mgmenu.addoption('1', "M249-SAW ($%s)"%int(m249))
  srmenu = popuplib.easymenu('srmenu', '_popup_choice', srmenu_select)
  srmenu.settitle("Sniper Rifles:")
  srmenu.addoption('1', "Scout ($%s)"%int(scout))
  srmenu.addoption('2', "G3/SG-1 ($%s)"%int(g3sg1))
  srmenu.addoption('3', "SG-550 ($%s)"%int(sg550))
  srmenu.addoption('4', "Arctice Warfare Police ($%s)"%int(awp))
  gmenu = popuplib.easymenu('gmenu', '_popup_choice', gmenu_select)
  gmenu.settitle("Grenades:")
  gmenu.addoption('1', "Flashbang Grenade ($%s)"%int(flashbang))
  gmenu.addoption('2', "Smoke Grenade ($%s)"%int(smokegrenade))
  gmenu.addoption('3', "High-Explosive Grenade ($%s)"%int(hegrenade))
  mmenu = popuplib.easymenu('mmenu', '_popup_choice', mmenu_select)
  mmenu.settitle("Misc:")
  mmenu.addoption('1', "Kevlar ($%s)"%int(kevlar))
  mmenu.addoption('2', "Kevlar and Helmet ($%s)"%int(assaultsuit))
  mmenu.addoption('3', "Nightvision ($%s)"%int(nvgs))
  mmenu.addoption('4', "Bomb Defusal Kit ($%s)"%int(defusekit))
  es.msg('#multi', '#default[#greenUndead Buy#default] by #lightgreenUndead #defaulthas been loaded!')

def unload():
  if es.exists('saycommand', buy_cmd):
    es.unregsaycmd(buy_cmd)
  popuplib.delete('bmenu')
  popuplib.delete('pmenu')
  popuplib.delete('smmenu')
  popuplib.delete('rmenu')
  popuplib.delete('mgmenu')
  popuplib.delete('srmenu')
  popuplib.delete('gmenu')
  popuplib.delete('mmenu')
  es.msg('#multi', '#default[#greenUndead Buy#default] by #lightgreenUndead #defaulthas been unloaded!')

def round_start(ev):
  global buyAllowed
  buyAllowed = True
  gamethread.delayedname(float(es.ServerVar('mp_buytime')) * 60, 'disableBuy', disableBuy)

def round_end(ev):
  gamethread.cancelDelayed('disableBuy')

def disableBuy():
  global buyAllowed
  buyAllowed = False
  for player in es.getUseridList():
    if popuplib.isqueued('bmenu', player):
      popuplib.unsendname('bmenu', player)
      es.tell(player, 'It is too late to buy something!')

def buy_cmd_reg():
  userid = es.getcmduserid()
  if playerlib.getPlayer(userid).inBuyZone():
    if buyAllowed:
      popuplib.send('bmenu', userid)
    else:
      es.tell(userid, 'It is too late to buy something!')
  else:
    es.tell(userid, 'You must be in a Buy Zone to use this command.')

def cash_check(userid, price):
  player = playerlib.getPlayer(userid)
  cash = player.getCash()
  if cash < price:
    es.tell(userid, 'Not enough cash!')
    return False
  else:
    player.cash -= price
    es.tell(userid, 'Transaction Successful!')
    return True

def bmenu_select(userid, choice, popupid):
  if choice == '1':
    popuplib.send('pmenu', userid)
  elif choice == '2':
    popuplib.send('smmenu', userid)
  elif choice == '3':
    popuplib.send('smenu', userid)
  elif choice == '4':
    popuplib.send('rmenu', userid)
  elif choice == '5':
    popuplib.send('mgmenu', userid)
  elif choice == '6':
    popuplib.send('srmenu', userid)
  elif choice == '7':
    popuplib.send('gmenu', userid)
  elif choice == '8':
    popuplib.send('mmenu', userid)

def pmenu_select(userid, choice, popupid):
  if choice == '1':
    price = int(glock)
    if cash_check(userid, price):
      es.server.queuecmd('es_xgive %s weapon_glock'%userid)
  elif choice == '2':
    price = int(usp)
    if cash_check(userid, price):
      es.server.queuecmd('es_xgive %s weapon_usp'%userid)
  elif choice == '3':
    price = int(p228)
    if cash_check(userid, price):
      es.server.queuecmd('es_xgive %s weapon_p228'%userid)
  elif choice == '4':
    price = int(deagle)
    if cash_check(userid, price):
      es.server.queuecmd('es_xgive %s weapon_deagle'%userid)
  elif choice == '5':
    price = int(fiveseven)
    if cash_check(userid, price):
      es.server.queuecmd('es_xgive %s weapon_fiveseven'%userid)
  elif choice == '6':
    price = int(elite)
    if cash_check(userid, price):
      es.server.queuecmd('es_xgive %s weapon_elite'%userid)

def smmenu_select(userid, choice, popupid):
  if choice == '1':
    price = int(mac10)
    if cash_check(userid, price):
      es.server.queuecmd('es_xgive %s weapon_mac10'%userid)
  elif choice == '2':
    price = int(tmp)
    if cash_check(userid, price):
      es.server.queuecmd('es_xgive %s weapon_tmp'%userid)
  elif choice == '3':
    price = int(mp5)
    if cash_check(userid, price):
      es.server.queuecmd('es_xgive %s weapon_mp5navy'%userid)
  elif choice == '4':
    price = int(ump)
    if cash_check(userid, price):
      es.server.queuecmd('es_xgive %s weapon_ump'%userid)
  elif choice == '5':
    price = int(p90)
    if cash_check(userid, price):
      es.server.queuecmd('es_xgive %s weapon_p90'%userid)

def smenu_select(userid, choice, popupid):
  if choice == '1':
    price = int(m3)
    if cash_check(userid, price):
      es.server.queuecmd('es_xgive %s weapon_m3'%userid)
  elif choice == '2':
    price = int(xm1014)
    if cash_check(userid, price):
      es.server.queuecmd('es_xgive %s weapon_xm1014'%userid)

def rmenu_select(userid, choice, popupid):
  if choice == '1':
    price = int(galil)
    if cash_check(userid, price):
      es.server.queuecmd('es_xgive %s weapon_galil'%userid)
  elif choice == '2':
    price = int(famas)
    if cash_check(userid, price):
      es.server.queuecmd('es_xgive %s weapon_famas'%userid)
  elif choice == '3':
    price = int(ak47)
    if cash_check(userid, price):
      es.server.queuecmd('es_xgive %s weapon_ak47'%userid)
  elif choice == '4':
    price = int(m4a1)
    if cash_check(userid, price):
      es.server.queuecmd('es_xgive %s weapon_m4a1'%userid)
  elif choice == '5':
    price = int(sg552)
    if cash_check(userid, price):
      es.server.queuecmd('es_xgive %s weapon_sg552'%userid)
  elif choice == '6':
    price = int(aug)
    if cash_check(userid, price):
      es.server.queuecmd('es_xgive %s weapon_aug'%userid)

def mgmenu_select(userid, choice, popupid):
  if choice == '1':
    price = int(m249)
    if cash_check(userid, price):
      es.server.queuecmd('es_xgive %s weapon_m249'%userid)

def srmenu_select(userid, choice, popupid):
  if choice == '1':
    price = int(scout)
    if cash_check(userid, price):
      es.server.queuecmd('es_xgive %s weapon_scout'%userid)
  elif choice == '2':
    price = int(g3sg1)
    if cash_check(userid, price):
      es.server.queuecmd('es_xgive %s weapon_g3sg1'%userid)
  elif choice == '3':
    price = int(sg550)
    if cash_check(userid, price):
      es.server.queuecmd('es_xgive %s weapon_sg550'%userid)
  elif choice == '4':
    price = int(awp)
    if cash_check(userid, price):
      es.server.queuecmd('es_xgive %s weapon_awp'%userid)

def gmenu_select(userid, choice, popupid):
  if choice == '1':
    price = int(flashbang)
    if cash_check(userid, price):
      es.server.queuecmd('es_xgive %s weapon_flashbang'%userid)
  elif choice == '2':
    price = int(smokegrenade)
    if cash_check(userid, price):
      es.server.queuecmd('es_xgive %s weapon_smokegrenade'%userid)
  elif choice == '3':
    price = int(hegrenade)
    if cash_check(userid, price):
      es.server.queuecmd('es_xgive %s weapon_hegrenade'%userid)

def mmenu_select(userid, choice, popupid):
  if choice == '1':
    price = int(kevlar)
    if cash_check(userid, price):
      es.server.queuecmd('es_xgive %s item_kevlar'%userid)
  elif choice == '2':
    price = int(assaultsuit)
    if cash_check(userid, price):
      es.server.queuecmd('es_xgive %s item_assaultsuit'%userid)
  elif choice == '3':
    price = int(nvgs)
    if cash_check(userid, price):
      es.server.queuecmd('es_xgive %s item_nvgs'%userid)
  elif choice == '4':
    price = int(defusekit)
    if cash_check(userid, price):
      es.server.queuecmd('es_xgive %s item_defusekit'%userid)
